[![Build Status](https://travis-ci.org/igorescodro/alkaa.svg?branch=master)](https://travis-ci.org/igorescodro/alkaa)
<a href="https://ktlint.github.io/"><img src="https://img.shields.io/badge/code%20style-%E2%9D%A4-FF4081.svg" alt="ktlint"></a>
<a href="https://codebeat.co/projects/github-com-igorescodro-alkaa-master"><img alt="codebeat badge" src="https://codebeat.co/badges/e742f8bf-2047-4a59-bdb4-14ed2b1d9d28" /></a>

# Alkaa

Alkaa (_begin_, _start_ in Finnish) is a simple to-do list project to study the latest components, architecure, tools, and APIs released in Android Platform. The project evolved a lot in the last year and now is available on Google Play! :heart:

<a href='https://play.google.com/store/apps/details?id=com.escodro.alkaa'><img alt='Get it on Google Play' src='https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png' height=64/></a>

<img src="https://lh3.googleusercontent.com/sUz8bqzv3BpcasgcPxOm21m4GYvxPZshcJnSYzSIdvYT-GfBMyNpPZ09UDBGdbMg=w1920-h1006" width="200"> <img src="https://lh3.googleusercontent.com/v6d72SO8nWjglaHckIIKRcZvKPDkIobTaiTPsAeN09kXe0z0PbZIkoG-BJNvqdCZnvY=w1920-h1006" width="200"> <img src="https://lh3.googleusercontent.com/xo_3zfVO1azfV0erPqWc2MkCejbD5gfo-yBWzkImleonGFrS6L73cul9mloLeEo6xHmK=w1920-h1006" width="200"> <img src="https://lh3.googleusercontent.com/tNDbS4fDLazUHZ6LH5S4Pa5M-JXvUmTKIvQ5dxm4zLl852kh0_eaYS5m8GkjetimiXQ=w1920-h1006" width="200">

Currently, this project covers the following topics:

#### Android
- [Kotlin](https://kotlinlang.org)
  - [High Order Functions](https://kotlinlang.org/docs/reference/lambdas.html)
  - [Extensions](https://kotlinlang.org/docs/reference/extensions.html#extensions)
  - [Gradle Kotlin DSL](https://github.com/gradle/kotlin-dsl)
- [Android Architecture Components](https://developer.android.com/topic/libraries/architecture)
  - [Data Binding](https://developer.android.com/topic/libraries/data-binding)
  - [Lifecycle](https://developer.android.com/topic/libraries/architecture/lifecycle)
  - [LiveData](https://developer.android.com/topic/libraries/architecture/livedata)
  - [Navigation](https://developer.android.com/topic/libraries/architecture/navigation)
  - [Room](https://developer.android.com/topic/libraries/architecture/room)
  - [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel)
  - [WorkManager](https://developer.android.com/topic/libraries/architecture/workmanager)
- [ListAdapter](https://developer.android.com/reference/android/support/v7/recyclerview/extensions/ListAdapter)  
- [Data Binding](https://developer.android.com/topic/libraries/data-binding/)
- [ConstraintLayout](https://developer.android.com/training/constraint-layout/)
- [Android KTX](https://developer.android.com/kotlin/ktx)
- [Modularization](https://www.youtube.com/watch?v=PZBg5DIzNww)

#### Third-Party
- [Koin](https://insert-koin.io)
- [RxJava 2 e RxAndroid 2](https://github.com/ReactiveX/RxAndroid)
- [Timber](https://github.com/JakeWharton/timber)

#### Quality check
- [klint](https://github.com/shyiko/ktlint)
- [detekt](https://github.com/arturbosch/detekt)
- [lint](https://developer.android.com/studio/write/lint)
- [codebeat](https://codebeat.co)

#### Tests
- [Espresso](https://developer.android.com/training/testing/espresso/)
- [UiAutomator](https://developer.android.com/training/testing/ui-automator)
- [Mockk](https://github.com/mockk/mockk)

#### Continuous Integration
- [Travis CI](https://travis-ci.org)

#### Tools covered but removed:
- [Dagger 2](https://google.github.io/dagger/) (replaced by Koin)

---
### Feel free to use the code the way you prefer - Enjoy your studies!
---

## License
``` 
Copyright 2018 Igor Escodro

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
``` 
